package pl.edu.agh.scaa.gui;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JTextField;

public class IntTextListener implements KeyListener {

	private Set<Character> numbers = new HashSet<Character>(Arrays.asList(new Character[] { '0', '1', '2', '3', '4',
			'5', '6', '7', '8', '9' }));

	@Override
	public void keyPressed(KeyEvent event) {
	}

	@Override
	public void keyReleased(KeyEvent event) {
		if (event.getSource() instanceof JTextField) {
			JTextField textField = (JTextField) event.getSource();
			try {
				Integer.parseInt(textField.getText());
			} catch (NumberFormatException exception) {
				String text = textField.getText();
				StringBuilder sb = new StringBuilder();
				for (char c : text.toCharArray()) {
					if (numbers.contains(c)) {
						sb.append(c);
					}
				}
				textField.setText(sb.toString());
			}
		}
	}

	@Override
	public void keyTyped(KeyEvent event) {
	}

}
